#include <cstdio>
#include <iostream>
#include <cassert>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <sstream>
#include "testlib.h"

using namespace std;

int cur_test = -1;
vector<int> MAXN({10, 100, 1000, (int)1e5});


string itoa(int x) 
{
    stringstream ss;
    string s;
    ss << x;
    ss >> s;
    return s;
}

int atoi(string s) 
{
    stringstream ss;
    int x;
    ss << s;
    ss >> x;
    return x;
}


void write_test(vector<int> test) 
{
    startTest(cur_test++);
    cerr << cur_test << endl;
    for (int i = 0; i < (int)test.size(); i++)
        cout << test[i];
    cout << endl;
}

char rand_digit(int x = 0)
{
    return rnd.next(10 - x) + x;
} 


void gen_rand(int n)
{
    vector<int> test(n);
    for (int i = 0; i < n; i++) 
    {
        test[i] = rand_digit();
    }
    write_test(test);    
}


vector<pair<int, int>> bad_pairs;

void init()
{
    for (int i = 1; i < 10; i++)
        for (int j = i; j < 10; j++)
            if (i % 3 != 0 && j % 3 != 0 && (i + j) % 3 != 0)
                bad_pairs.push_back({i, j});
}

void gen_del_pair(int n, int pi)
{
    vector<int> test(n);
    int x = bad_pairs[pi].first;
    int y = bad_pairs[pi].second;
    for (int i = 0; i < n - 2; i++) 
    {
        test[i] = rnd.next(4) * 3;
    }
    test[n - 2] = x;
    test[n - 1] = y;
    shuffle(test.begin(), test.end());
    write_test(test);    
}

void gen_del_single(int n, int x)
{
    vector<int> test(n);
    int cur_rem = 0;
    for (int i = 0; i < n - 1; i++) 
    {
        if (rnd.next(3) == 0)
            test[i] = rnd.next(4) * 3;
        else
            test[i] = rand_digit(x);
        cur_rem += test[i];
    }
    test[n - 1] = x;
    cur_rem %= 3;
    int i = 0;    
    while (i < n && cur_rem != 0) 
    {
        if (test[i] == 0)
            i++;
        test[i]--;
        cur_rem--;
    }
    assert(cur_rem == 0);
    shuffle(test.begin(), test.end());
    write_test(test);    
}





int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    init();
    cur_test = atoi(argv[1]);
    for (int i = 0; i < (int)MAXN.size(); i++)
    {
        int cur_max = MAXN[i];
        cerr << "start group: " << cur_max << endl;
        for (int j = 0; j < 3; j++) 
        {
            gen_del_single(rnd.next(cur_max / 2) + cur_max /  2 + 1, rand_digit());
            gen_del_pair(rnd.next(cur_max / 2) + cur_max /  2 + 1, rnd.next(bad_pairs.size()));
            gen_rand(rnd.next(cur_max / 2) + cur_max /  2 + 1);
            gen_rand(rnd.next(cur_max / 2) + cur_max /  2 + 1);
        }
        gen_del_single(cur_max, rand_digit());
        gen_del_pair(cur_max, rnd.next(bad_pairs.size()));
        gen_rand(cur_max);
        cerr << "end group: " << cur_max << endl;
    }
    return 0;
}