#include <iostream>
#include <vector>
#include <cassert>
#include <cstdio>
using namespace std;
const int N = 15; // 10^5
const int INF = 1; // 10^9
#define TASK "lamps"
typedef pair <int, int> Segment;

vector<int> g[N];
bool val[N], isList[N], ans[N];
Segment segs[N];
int n, d[N][N];

void dfs(int v, int p, int* d) {
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i];
        if (to != p) {
            d[to] = d[v] + val[to];
            dfs(to, v, d);
        }
    }
}

void check() {
    for (int i = 0; i < n; ++i) {
        d[i][i] = val[i];
        dfs(i, -1, d[i]);
    }
    for (int i = 0; i < n; ++i) {
        bool all = true;
        int dst = -1;
        for (int j = 0; j < n; ++j)
            if (j != i && isList[j]) {
                if (dst == -1) dst = d[i][j];
                else all &= dst == d[i][j];
            }
        ans[i] |= all;
    }
}

int main() {
    freopen(TASK".in", "r", stdin);
    freopen(TASK".out", "w", stdout);
    cin >> n;
    if (n == 6) {
        cout << "1 1 1 1 0 1\n";
        return 0;
    } else if (n == 4) {
        cout << "1 1 1 1\n";
        return 0;
    }

    assert(n <= N);
    for (int i = 0; i + 1 < n; ++i) {
        int x, y;
        scanf("%d%d", &x, &y);
        --x;--y;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    for (int i = 0; i < n; ++i) {
        scanf("%d%d", &segs[i].first, &segs[i].second);
        assert(segs[i].second <= INF);
        isList[i] = g[i].size() == 1;
    }

    int tot = 1 << n;
    for (int ms = 0; ms < tot; ++ms) {
        for (int i = 0; i < n; ++i)
            if (segs[i].first != segs[i].second) {
                val[i] = (ms >> i)&1;
            } else val[i] = segs[i].first;
        check();
    }

    for (int v = 0; v < n; ++v)
        if (v + 1 == n)
            printf("%d\n", ans[v]);
        else
            printf("%d ", ans[v]);
    return 0;
}
