#include <iostream>
#include <vector>
#include <cassert>
#include <cstdio>
using namespace std;
const int N = 2000;
const int INF = 1000000000;
#define TASK "lamps"

typedef pair<int, int> Segment;
vector<int> g[N];
Segment segs[N];
bool ans[N];

Segment inters(const Segment& a, const Segment& b) {
    return make_pair(max(a.first, b.first), min(a.second, b.second));
}

Segment dfs(int v, int p) {
    if (g[v].size() == 1 && p != -1) {
        return segs[v];
    }
    Segment cur = make_pair(0, INF);
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i];
        if (to != p) {
            cur = inters(cur, dfs(to, v));
        }
    }
    if (cur.first <= cur.second) {
        return make_pair(cur.first + segs[v].first, cur.second + segs[v].second);
    } else
        return cur;
}

int main() {
    freopen(TASK".in", "r", stdin);
    freopen(TASK".out", "w", stdout);

    int n;
    cin >> n;
    assert(n <= N);
    for (int i = 0; i + 1 < n; ++i) {
        int x, y;
        scanf("%d%d", &x, &y);
        --x;--y;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    for (int i = 0; i < n; ++i) {
        scanf("%d%d", &segs[i].first, &segs[i].second);
    }

    for (int v = 0; v < n; ++v) {
        Segment seg = dfs(v, -1);
        ans[v] = seg.first <= seg.second;
    }

    for (int v = 0; v < n; ++v)
        if (v + 1 == n)
            printf("%d\n", ans[v]);
        else
            printf("%d ", ans[v]);
    return 0;
}
